#include <Windows.h>
#include "stdio.h"
#include "math.h"
#include "stdlib.h"

#include "global.h"
#include "dibengine.h"

extern HFONT font,italic_font,underline_font,bold_font,tiny_font,small_bold_font;
extern HDC main_dc,main_dc2,main_dc3;
extern HCURSOR cursors[8];
extern HWND	mainPtr;

extern scenario_data_type scenario;
extern town_record_type town;
extern big_tr_type t_d;
extern outdoor_record_type current_terrain;
extern scen_item_data_type scen_data;
extern short borders[4][50];
extern unsigned char border_floor[4][50];
extern unsigned char border_height[4][50];
extern short cur_town;
extern location cur_out;
extern short current_drawing_mode;
extern short town_type ;
extern short current_height_mode ;
extern Boolean editing_town,using_osx;
extern short cur_viewing_mode;
extern short overall_mode;
extern short ulx,uly;

extern HWND	mainPtr;
extern short cen_x, cen_y,current_terrain_type;

extern short available_dlog_buttons[NUM_DLOG_B];
extern short max_dim[3];
extern short dungeon_font_num,geneva_font_num;
extern RECT windRect;
extern RECT world_screen;


extern HWND right_sbar;

extern Boolean file_is_loaded;

extern char *button_strs[140];
extern location cur_out;

extern short current_floor_drawn, current_terrain_drawn;

extern RECT world_screen;
	// border rects order: top, left, bottom, right //
extern RECT border_rect[4];
extern RECT terrain_rects[264],terrain_rect_base;							
extern RECT palette_buttons[8][6];
extern RECT large_edit_ter_rects[9][9];
extern RECT small_edit_ter_rects[MAX_TOWN_SIZE][MAX_TOWN_SIZE];
extern RECT left_text_lines[10];
extern RECT right_text_lines[5];

extern short selected_item_number;
extern item_type copied_item;
extern creature_start_type copied_creature;
extern Boolean hintbook_mode;

HDIB dlg_buttons_gworld = NULL;
HDIB dialog_gworld = NULL,dlogpics_gworld = NULL,mixed_gworld = NULL,talkfaces_gworld = NULL;
HDIB editor_mixed = NULL,terrain_buttons_gworld = NULL,ter_draw_gworld = NULL;

HDIB dlog_horiz_border_bottom_gworld = NULL;
HDIB dlog_horiz_border_top_gworld = NULL;
HDIB dlog_vert_border_gworld = NULL;
HDIB pattern_gworld = NULL;
HDIB ed_pattern_gworld = NULL;
HDIB dialog_pattern_gworld = NULL;
HDIB pat_source_gworld = NULL;
HDIB buttons_gworld = NULL;
HDIB ter_resize_buffer_gworld = NULL;

// Other game rectangles
RECT terrain_buttons_rect = {0,0,210,550}; /**/
RECT terrain_rect_gr_size = {0,0,512,512};


RECT blue_button_from = {91,112,107,126}; /**/						
RECT start_button_from = {70,112,91,119};
RECT base_small_button_from = {0,103,10,113};
RECT palette_button_base = {0,0,25,18};
RECT left_button_base = {5,5,200,21};

RECT buttons_from[NUM_BUTTONS] = {{0,0,23,23},{46,0,108,23},{0,132,102,155},{126,23,142,36},
								{0,92,62,115},{0,69,62,92},{126,46,188,69},{126,69,188,92}, // l, r, u, d
								{172,30,184,42},{172,30,184,42},{196,30,208,42},{0,23,62,46},  // small, small, , done
								{0,46,62,69},{208,30,226,46},{204,132,222,148},{172,0,202,30}}; // cancel, up arrow  down arrow

// Palette UL x = 525 y = 382

// graphics library
HDIB graphics_library[MAX_NUM_SHEETS_IN_LIBRARY];
graphic_id_type graphics_library_index[MAX_NUM_SHEETS_IN_LIBRARY];
short num_sheets_in_library = 0;
HBITMAP bw_bitmap = NULL;

char current_string[256] = "";
char current_string2[256] = "";
char *attitude_types[4] = {"Friendly","Neutral","Hostile, Type A","Hostile, Type B"};
char *facings[4] = {"North","West","South","East"};

short small_what_drawn[64][64];
short small_what_floor_drawn[64][64];
extern Boolean small_any_drawn;

Boolean showed_graphics_error = FALSE;

char error_str[256];

void Set_up_win ()
{
	short i,j;


	for (i = 0; i < 8; i++)
		for (j = 0; j < 6; j++) {
		palette_buttons[i][j] = palette_button_base;
		OffsetRect(&palette_buttons[i][j],i * 25 + PALETTE_BUT_UL_X, j * 17 + PALETTE_BUT_UL_Y);
		}	

	for (i = 0; i < 9; i++)
		for (j = 0; j < 9; j++) {
			SetRect(&large_edit_ter_rects[i][j],TERRAIN_BORDER_WIDTH + i * BIG_SPACE_SIZE,TERRAIN_BORDER_WIDTH + j * BIG_SPACE_SIZE,
			  TERRAIN_BORDER_WIDTH + (i + 1) * BIG_SPACE_SIZE,TERRAIN_BORDER_WIDTH + (j + 1) * BIG_SPACE_SIZE);
			//SetRect(&large_edit_ter_rects[i][j],TER_RECT_UL_X + i * BIG_SPACE_SIZE,TER_RECT_UL_Y + j * BIG_SPACE_SIZE,
			  //TER_RECT_UL_X + (i + 1) * BIG_SPACE_SIZE,TER_RECT_UL_Y + (j + 1) * BIG_SPACE_SIZE);
			}
	for (i = 0; i < MAX_TOWN_SIZE; i++)
		for (j = 0; j < MAX_TOWN_SIZE; j++) {
			SetRect(&small_edit_ter_rects[i][j],  i * SMALL_SPACE_SIZE,  j * SMALL_SPACE_SIZE,
			    (i + 1) * SMALL_SPACE_SIZE,  (j + 1) * SMALL_SPACE_SIZE);
			//SetRect(&small_edit_ter_rects[i][j],TER_RECT_UL_X + i * SMALL_SPACE_SIZE,TER_RECT_UL_Y + j * SMALL_SPACE_SIZE,
			  //TER_RECT_UL_X + (i + 1) * SMALL_SPACE_SIZE,TER_RECT_UL_Y + (j + 1) * SMALL_SPACE_SIZE);
			}
	for (i = 0; i < 264; i++)
		SetRect(&terrain_rects[i],3 + (i % 12) * (TER_BUTTON_SIZE + 1),2 + (i / 12) * (TER_BUTTON_SIZE + 1),
			3 + (i % 12) * (TER_BUTTON_SIZE + 1) + TER_BUTTON_SIZE,2 + (i / 12) * (TER_BUTTON_SIZE + 1) + TER_BUTTON_SIZE);

	for (short i = 0; i < MAX_NUM_SHEETS_IN_LIBRARY; i++) {
		graphics_library[i] = NULL;
		}
	RECT world_screen = {large_edit_ter_rects[0][0].left,large_edit_ter_rects[0][0].top,
		large_edit_ter_rects[8][8].right,large_edit_ter_rects[8][8].bottom}; /**/

	MacInsetRect(&world_screen,-15,-15);
	OffsetRect(&world_screen,TER_RECT_UL_X,TER_RECT_UL_Y);

	for (i = 0; i < 4; i++)
		border_rect[i] = world_screen;
	border_rect[0].bottom = border_rect[0].top + 15;
	border_rect[1].right = border_rect[1].left + 15;
	border_rect[2].top = border_rect[2].bottom - 15;
	border_rect[3].left = border_rect[3].right - 15;
			
	load_main_screen();
}

void load_main_screen()
{
	short i,j;	
	
	main_dc = GetDC(mainPtr);

	SelectObject(main_dc,font);
	SetBkMode(main_dc,TRANSPARENT);
	SetStretchBltMode(main_dc,STRETCH_DELETESCANS);
	main_dc2 = CreateCompatibleDC(main_dc);
	SetMapMode(main_dc2,GetMapMode(main_dc));
	SetStretchBltMode(main_dc2,STRETCH_DELETESCANS);
	main_dc3 = CreateCompatibleDC(main_dc);
	SetMapMode(main_dc3,GetMapMode(main_dc));
	SetStretchBltMode(main_dc3,STRETCH_DELETESCANS);

	terrain_buttons_gworld = DibCreate (terrain_buttons_rect.right,terrain_buttons_rect.bottom, 16,0);
	
	ter_draw_gworld = DibCreate (terrain_rect_gr_size.right,terrain_rect_gr_size.bottom, 16,0);

	ter_resize_buffer_gworld = DibCreate (100,100, 16,0);


	buttons_gworld = load_pict(2000);
	//for (i = 0; i < 14; i++) 
	 //   bg[i] = GetPixPat (128 + i);
	//for (i = 0; i < 29; i++) 
	 //   map_pat[i] = GetPixPat (200 + i);

	bw_bitmap = CreateBitmap(72,72,1,1,NULL);
	pattern_gworld = DibCreate (192,256, 16,0);
	dialog_pattern_gworld = DibCreate (192,256, 16,0);
	pat_source_gworld = load_pict(4900);

	editor_mixed = load_pict(4902);

	mixed_gworld = load_pict(903);
	if (dlog_horiz_border_bottom_gworld == NULL)
		dlog_horiz_border_bottom_gworld = load_pict(842);//(52);
	if (dlog_horiz_border_top_gworld == NULL)
		dlog_horiz_border_top_gworld = load_pict(841);//(51);
	if (dlog_vert_border_gworld == NULL)
		dlog_vert_border_gworld = load_pict(840);//(850);
	if (ed_pattern_gworld == NULL)
		ed_pattern_gworld = load_pict(4901);//(850);
}

// lose other graphics
void lose_graphics() 
{
	short i,j;

	if (bw_bitmap != NULL) {
		DeleteObject(bw_bitmap);
		bw_bitmap = NULL;
		}
	refresh_graphics_library();
	delete_graphic(&dialog_pattern_gworld);
	delete_graphic(&pattern_gworld);
	delete_graphic(&pat_source_gworld);
	delete_graphic(&dlg_buttons_gworld);
	delete_graphic(&dialog_gworld);
	delete_graphic(&dlogpics_gworld);
	delete_graphic(&mixed_gworld);
	delete_graphic(&talkfaces_gworld);
	delete_graphic(&editor_mixed);
	delete_graphic(&terrain_buttons_gworld);
	delete_graphic(&ter_draw_gworld);
	delete_graphic(&dlog_horiz_border_bottom_gworld);
	delete_graphic(&dlog_horiz_border_top_gworld);
	delete_graphic(&dlog_vert_border_gworld);
	delete_graphic(&pattern_gworld);
	delete_graphic(&ed_pattern_gworld);
	delete_graphic(&dialog_pattern_gworld);
	delete_graphic(&pat_source_gworld);
	delete_graphic(&buttons_gworld);
	delete_graphic(&ter_resize_buffer_gworld);
	
	DeleteDC(main_dc);
	DeleteDC(main_dc2);
	DeleteDC(main_dc3);

	DeleteObject(font);
	DeleteObject(small_bold_font);
	DeleteObject(italic_font);
	DeleteObject(underline_font);
	DeleteObject(bold_font);
	DeleteObject(tiny_font);

	}

void redraw_screen()
{
	
	// fill left with pattern
	RECT to_rect = windRect;
	to_rect.right = RIGHT_BUTTONS_X_SHIFT;
	paint_pattern(NULL,1,to_rect,0);
	
	// fill lower right corner
	to_rect = windRect;
	to_rect.left = terrain_buttons_rect.right + RIGHT_BUTTONS_X_SHIFT;
	to_rect.top = 22 * (TER_BUTTON_SIZE + 1) + 1;
	paint_pattern(NULL,1,to_rect,0);

	small_any_drawn = TRUE;
	draw_main_screen();
}

void draw_main_screen()
{
	short i;
	RECT draw_rect;

	place_right_buttons(0);
	draw_terrain();
	ShowScrollBar(right_sbar,SB_CTL,TRUE);
}


void set_up_terrain_buttons()
{
	short i,j,pic,small_i;
	RECT ter_from,ter_to,ter_from_base = {0,0,16,16};
	RECT tiny_from,tiny_to,dest_rect; 
	
	RECT palette_from = {0,0,0,0},palette_to;
	HDC hdc;
	HBITMAP store_bmp;


 	paint_pattern(terrain_buttons_gworld,0,terrain_buttons_rect,2);
	
	// frame rect around buttons
	hdc = CreateCompatibleDC(main_dc);
	SetBkMode(hdc,TRANSPARENT);
	SelectObject(hdc,bold_font);
	store_bmp = (HBITMAP) SelectObject(hdc,DibBitmapHandle(terrain_buttons_gworld));
	put_rect_in_gworld(hdc,terrain_buttons_rect,0,0,0);
	SelectObject(hdc,store_bmp);
	DeleteObject(hdc);
	 
 	if (file_is_loaded == FALSE) 
		return;
			
 	// first make terrain buttons
	for (i = 0; i < 264; i++) 
		if ((i < 256) || (current_drawing_mode > 0)) {
			ter_from = ter_from_base;
			
			graphic_id_type a;
			
			short icon_to_use;
			Boolean do_this_item = TRUE;
			short store_ter_type;
			
			switch (current_drawing_mode) {
				case 0:
					a = scen_data.scen_floors[i].ed_pic;
					OffsetRect(&ter_from,(1 + TER_BUTTON_SIZE) * (a.which_icon % 10) + 1,(1 + TER_BUTTON_SIZE) * (a.which_icon / 10) + 1);
					if (a.not_legit())
						do_this_item = FALSE;
					break;
				case 1: case 2:
					short sbar_pos = GetControlValue(right_sbar);
					store_ter_type = sbar_pos * 12 + i;
					if (sbar_pos * 12 + i < 512) {
						a = scen_data.scen_ter_types[sbar_pos * 12 + i].ed_pic;
						OffsetRect(&ter_from,(1 + TER_BUTTON_SIZE) * (a.which_icon % 10) + 1,(1 + TER_BUTTON_SIZE) * (a.which_icon / 10) + 1);
						if (a.not_legit())
							do_this_item = FALSE;
						}
						else do_this_item = FALSE;
					break;

				}
				
			if (do_this_item == TRUE) {
				short index = safe_get_index_of_sheet(&a);
				if (index < 0) {
					if (current_drawing_mode == 0)
						cant_draw_graphics_error(a,"Error was for floor type",i);
						else cant_draw_graphics_error(a,"Error was for terrain type",store_ter_type);
					return;	
					}

				rect_draw_some_item(graphics_library[index],
					ter_from,terrain_buttons_gworld,terrain_rects[i],0,0);
				}
		}
	
	// palette buttons
	for (i = 0; i < 8; i++)
		for (j = 0; j < ((editing_town == TRUE) ? 6 : 3); j++) {
			RECT from_rect = {PALETTE_BUT_WIDTH * i,PALETTE_BUT_HEIGHT * j,
				PALETTE_BUT_WIDTH * (i + 1),PALETTE_BUT_HEIGHT * (j + 1) + 1}; /**/
			RECT to_rect = palette_buttons[i][j];
			//OffsetRect(&to_rect,RIGHT_BUTTONS_X_SHIFT,0);
			to_rect.right++;
			from_rect.right++;
			//to_rect.bottom++;
			//from_rect.bottom++;
			
			rect_draw_some_item(editor_mixed,
				from_rect,terrain_buttons_gworld,to_rect,0,0);
			
			}


}

void delete_graphic(HDIB *to_delete)
{
	if (*to_delete == NULL)
		return;
		
	DibDelete(*to_delete);
	*to_delete = NULL;
}

Boolean place_terrain_icon_into_ter_large(graphic_id_type icon,short in_square_x,short in_square_y)
{
	RECT to_rect = large_edit_ter_rects[in_square_x][in_square_y];
	RECT from_rect;
	graphic_id_type a = icon;

	short index = safe_get_index_of_sheet(&a);
	if (index < 0) {
		//cant_draw_graphics_error(a);
		return FALSE;	
		}		
	SetRect(&from_rect,1 + (TER_BUTTON_SIZE + 1) * (a.which_icon % 10),1 + (TER_BUTTON_SIZE + 1) * (a.which_icon / 10),
	  1 + (TER_BUTTON_SIZE + 1) * (a.which_icon % 10) + TER_BUTTON_SIZE,1 + (TER_BUTTON_SIZE + 1) * (a.which_icon / 10) + TER_BUTTON_SIZE);

	RECT buffer_to_rect = to_rect;
	ZeroRectCorner(&buffer_to_rect);
	rect_draw_some_item(graphics_library[index],
		from_rect,ter_resize_buffer_gworld,buffer_to_rect,0,0);

	rect_draw_some_item(ter_resize_buffer_gworld,
		buffer_to_rect,ter_draw_gworld,to_rect,1,0);


	return TRUE;
}

void draw_ter_large()
{
	short q,r,x,y,i,small_i;
	location where_draw;
	RECT draw_rect;	
	short t_to_draw,floor_to_draw,height_to_draw;
	RECT source_rect,tiny_to,tiny_to_base = {15,15,22,22},tiny_from,from_rect,to_rect;
	graphic_id_type a;
	short index;
	char str[256];
	HDC hdc;
	HBITMAP store_bmp;
	
 	paint_pattern(ter_draw_gworld,0,terrain_rect_gr_size,1);

	RECT whole_area_rect = {large_edit_ter_rects[0][0].left,large_edit_ter_rects[0][0].top,
		large_edit_ter_rects[8][8].right,large_edit_ter_rects[8][8].bottom}; /**/
	
	MacInsetRect(&whole_area_rect,-15,-15);
	ZeroRectCorner(&whole_area_rect);

	hdc = CreateCompatibleDC(main_dc);
	SetBkMode(hdc,TRANSPARENT);
	SelectObject(hdc,bold_font);
	store_bmp = (HBITMAP) SelectObject(hdc,DibBitmapHandle(ter_draw_gworld));
	
	put_rect_in_gworld(hdc,whole_area_rect,0,0,0);
	MacInsetRect(&whole_area_rect,15,15);
	put_rect_in_gworld(hdc,whole_area_rect,0,0,0);
	MacInsetRect(&whole_area_rect,-15,-15);
	
	if (file_is_loaded == FALSE) {
		to_rect = whole_area_rect;
		MacInsetRect(&to_rect,16,16);
		fill_rect_in_gworld(hdc,to_rect,230,230,230);

		SelectObject(hdc,store_bmp);
		DeleteObject(hdc);

		to_rect = whole_area_rect;
		OffsetRect(&to_rect,TER_RECT_UL_X,TER_RECT_UL_Y);
		rect_draw_some_item(ter_draw_gworld,
			whole_area_rect,ter_draw_gworld,to_rect,0,1);			

		return;
		}
		
	//SetPort(mainPtr);
	for (q = 0; q < 9; q++) 
		for (r = 0; r < 9; r++) {
			where_draw.x = q; where_draw.y = r;
			
			if ((editing_town == FALSE) && (cen_x + q - 4 == -1)) {
				t_to_draw = borders[3][cen_y + r - 4];
				floor_to_draw = border_floor[3][cen_y + r - 4];		
				height_to_draw = border_height[3][cen_y + r - 4];		
				}
			else if ((editing_town == FALSE) && (cen_x + q - 4 == 48)) {
				t_to_draw = borders[1][cen_y + r - 4];
				floor_to_draw = border_floor[1][cen_y + r - 4];		
				height_to_draw = border_height[1][cen_y + r - 4];		
				}
			else if ((editing_town == FALSE) && (cen_y + r - 4 == -1)) {
				t_to_draw = borders[0][cen_x + q - 4];
				floor_to_draw = border_floor[0][cen_x + q - 4];		
				height_to_draw = border_height[0][cen_x + q - 4];		
				}
			else if ((editing_town == FALSE) && (cen_y + r - 4 == 48)) {
				t_to_draw = borders[2][cen_x + q - 4];
				floor_to_draw = border_floor[2][cen_x + q - 4];		
				height_to_draw = border_height[2][cen_x + q - 4];		
				}
			else {
				t_to_draw = (editing_town) ? t_d.terrain[cen_x + q - 4][cen_y + r - 4] : current_terrain.terrain[cen_x + q - 4][cen_y + r - 4];		
				floor_to_draw = (editing_town) ? t_d.floor[cen_x + q - 4][cen_y + r - 4] : current_terrain.floor[cen_x + q - 4][cen_y + r - 4];		
				height_to_draw = (editing_town) ? t_d.height[cen_x + q - 4][cen_y + r - 4] : current_terrain.height[cen_x + q - 4][cen_y + r - 4];		
				}

			location loc_drawn = {cen_x + q - 4,cen_y + r - 4};
			
			// draw floor
			a = scen_data.scen_floors[floor_to_draw].ed_pic;
			
			// if graphic is underfined for floor, just draw white
			if (a.not_legit()) {
				fill_rect_in_gworld(hdc,large_edit_ter_rects[q][r],230,230,230);
				}
				else {
					SelectObject(hdc,store_bmp);
					if (place_terrain_icon_into_ter_large(a,q,r) == FALSE)
						cant_draw_graphics_error(a,"Error was for floor type",floor_to_draw);
					SelectObject(hdc,DibBitmapHandle(ter_draw_gworld));
					}
					
			// draw terrain
			if (t_to_draw > 0) {
				SelectObject(hdc,store_bmp);
				a = scen_data.scen_ter_types[t_to_draw].ed_pic;
				if (a.not_legit() == FALSE)
					if (place_terrain_icon_into_ter_large(a,q,r) == FALSE)
						cant_draw_graphics_error(a,"Error was for terrain type",t_to_draw);
				SelectObject(hdc,DibBitmapHandle(ter_draw_gworld));
				}

			// Town mode: draw all instances
			if (editing_town) {
				
				SelectObject(hdc,store_bmp);
				// draw barrels, etc
				if (is_barrel(loc_drawn.x,loc_drawn.y)) {
					a.which_sheet = 680;
					a.which_icon = 75;
					place_terrain_icon_into_ter_large(a,q,r);
					}
				if (is_crate(loc_drawn.x,loc_drawn.y)) {
					a.which_sheet = 680;
					a.which_icon = 76;
					place_terrain_icon_into_ter_large(a,q,r);
					}
				if (is_web(loc_drawn.x,loc_drawn.y)) {
					a.which_sheet = 680;
					a.which_icon = 78;
					place_terrain_icon_into_ter_large(a,q,r);
					}
				if (is_fire_barrier(loc_drawn.x,loc_drawn.y)) {
					a.which_sheet = 686;
					a.which_icon = 40;
					place_terrain_icon_into_ter_large(a,q,r);
					}
				if (is_force_barrier(loc_drawn.x,loc_drawn.y)) {
					a.which_sheet = 686;
					a.which_icon = 41;
					place_terrain_icon_into_ter_large(a,q,r);
					}
				// draw stains
				for (short j = 0; j < 8; j++)
					if (is_sfx(loc_drawn.x,loc_drawn.y,j)) {
						a.which_sheet = 680;
						a.which_icon = 63 + j;
						place_terrain_icon_into_ter_large(a,q,r);
						}

			
				// draw ter scripts
				for (i = 0; i < NUM_TER_SCRIPTS; i++)
					if (town.ter_scripts[i].exists) {
						draw_ter_script(i,loc_drawn,q,r);
						}									
				// draw creatures
				for (i = 0; i < NUM_TOWN_PLACED_CREATURES; i++)
					if (town.creatures[i].exists()) {
						draw_creature(hdc,store_bmp,i,loc_drawn,q,r);
						}	
				// draw items
				for (i = 0; i < NUM_TOWN_PLACED_ITEMS; i++)
					if (town.preset_items[i].exists()) {
						draw_item(hdc,store_bmp,i,loc_drawn,q,r);
						}	
								
				// draw selected instance
				if ((selected_item_number >= 7000) && (selected_item_number < 7000 + NUM_TOWN_PLACED_CREATURES)) {
					draw_creature(hdc,store_bmp,selected_item_number % 1000,loc_drawn,q,r);
					}
				if ((selected_item_number >= 11000) && (selected_item_number < 11000 + NUM_TOWN_PLACED_ITEMS)) {
					draw_item(hdc,store_bmp,selected_item_number % 1000,loc_drawn,q,r);
					}						
				}
			SelectObject(hdc,DibBitmapHandle(ter_draw_gworld));
			
			// draw height
			if (current_drawing_mode == 2) {
				sprintf(str,"%d",height_to_draw);
				//  ((editing_town) ? t_d.height[loc_drawn.x][loc_drawn.y] : current_terrain.height[loc_drawn.x][loc_drawn.y]);
				to_rect = large_edit_ter_rects[q][r];
				OffsetRect(&to_rect,3,14);
				to_rect.left = to_rect.right - ((strlen(str) > 1) ? 23 : 14);
				win_draw_string_outline(hdc,to_rect,str,2,10);		
				}
				
			put_rect_in_gworld(hdc,large_edit_ter_rects[q][r],0,0,0);

			short small_icon_position = 0;

			SelectObject(hdc,store_bmp);
				
			// now place the tiny icons in the lower right corner
			// first, stuff that is done for both town and outdoors
			// signs
			if (scen_data.scen_ter_types[t_to_draw].special == 39) {
				place_ter_icon_on_tile(q,r,small_icon_position,20);
				small_icon_position++;
				}			
			if (scen_data.scen_ter_types[t_to_draw].special == 40) {
				place_ter_icon_on_tile(q,r,small_icon_position,21);
				small_icon_position++;
				}			
			
			// icons for secret doors
			if (((t_to_draw >= 18) && (t_to_draw <= 21)) || ((t_to_draw >= 54) && (t_to_draw <= 57))) {
				place_ter_icon_on_tile(q,r,small_icon_position,26);
				small_icon_position++;
				}
			// icons for floor damage
			if ((scen_data.scen_ter_types[t_to_draw].special == 1) || 
			  (scen_data.scen_floors[floor_to_draw].special == 1)) {
				place_ter_icon_on_tile(q,r,small_icon_position,37);
				small_icon_position++;
			  	}
			if ((scen_data.scen_ter_types[t_to_draw].special == 2) || 
			  (scen_data.scen_floors[floor_to_draw].special == 2)) {
				place_ter_icon_on_tile(q,r,small_icon_position,38);
				small_icon_position++;
			  	}
			if ((scen_data.scen_ter_types[t_to_draw].special == 3) || 
			  (scen_data.scen_floors[floor_to_draw].special == 3)) {
				place_ter_icon_on_tile(q,r,small_icon_position,39);
				small_icon_position++;
			  	}

			if ((scen_data.scen_ter_types[t_to_draw].special == 6) || 
			  (scen_data.scen_floors[floor_to_draw].special == 6)) {
				place_ter_icon_on_tile(q,r,small_icon_position,22);
				small_icon_position++;
			  	}
			  	
			// then town only tiny icons
			if (editing_town) {
				for (i = 0; i < 4; i++)		
					if (same_point(loc_drawn,town.start_locs[i])) {
						place_ter_icon_on_tile(q,r,small_icon_position,i);
						small_icon_position++;

						}	


				for (i = 0; i < NUM_WAYPOINTS; i++)		
					if (same_point(loc_drawn,town.waypoints[i])) {
						place_ter_icon_on_tile(q,r,small_icon_position,10 + i);
						small_icon_position++;
						}	

				for (i = 0; i < 6; i++)		
					if (same_point(loc_drawn,town.respawn_locs[i])) {
						place_ter_icon_on_tile(q,r,small_icon_position,24);
						small_icon_position++;
						}	

				// start scenario icon
				if ((scenario.start_in_what_town == cur_town) && (same_point(loc_drawn,scenario.what_start_loc_in_town))) {
					place_ter_icon_on_tile(q,r,small_icon_position,23);
					small_icon_position++;
					}

					
				// blocked spaces
				if (is_blocked(loc_drawn.x,loc_drawn.y)) {
					place_ter_icon_on_tile(q,r,small_icon_position,22);
					small_icon_position++;
					}			
				}
			SelectObject(hdc,DibBitmapHandle(ter_draw_gworld));
			
			// Outdoor mode: draw tiny icons
			if (editing_town == FALSE) {

				SelectObject(hdc,store_bmp);
				
				// WANDERING MONST ICON
				for (i = 0; i < 4; i++)		
					if (same_point(loc_drawn,current_terrain.wandering_locs[i])) {
						place_ter_icon_on_tile(q,r,small_icon_position,24);
						small_icon_position++;
						}	

				// Preset MONST ICON
				for (i = 0; i < 8; i++)		
					if ((current_terrain.preset[i].start_loc.x > 0) &&
					  (same_point(loc_drawn,current_terrain.preset[i].start_loc))) {
						place_ter_icon_on_tile(q,r,small_icon_position,25);
						small_icon_position++;
						}	
				
				// start scenario icon
				if ((same_point(cur_out,scenario.what_outdoor_section_start_in)) && 
				  (same_point(loc_drawn,scenario.start_where_in_outdoor_section))) {
					place_ter_icon_on_tile(q,r,small_icon_position,23);
					small_icon_position++;
					}
				SelectObject(hdc,DibBitmapHandle(ter_draw_gworld));
				}
			}
	

	// draw Various Rectangles
	RECT rectangle_draw_rect;
	RECT clip_rect = whole_area_rect;
	MacInsetRect(&clip_rect,15,15);

	// Town mode: special encs and other rectangles
	if (editing_town) {
		for (i = 0; i < NUM_TOWN_PLACED_SPECIALS; i++)
			if ((town.spec_id[i] >= 0) && (town.spec_id[i] < 255)) {
				rectangle_draw_rect.left = 15 + BIG_SPACE_SIZE * (town.special_rects[i].left - cen_x + 4);
				rectangle_draw_rect.right = 15 + BIG_SPACE_SIZE * (town.special_rects[i].right - cen_x + 4 + 1) - 1;
				rectangle_draw_rect.top = 15 + BIG_SPACE_SIZE * (town.special_rects[i].top - cen_y + 4);
				rectangle_draw_rect.bottom = 15 + BIG_SPACE_SIZE * (town.special_rects[i].bottom - cen_y + 4 + 1) - 1;				
				MacInsetRect(&rectangle_draw_rect,1,1);
				put_clipped_rect_in_gworld(hdc,rectangle_draw_rect,clip_rect,200,200,255);
				MacInsetRect(&rectangle_draw_rect,1,1);
				put_clipped_rect_in_gworld(hdc,rectangle_draw_rect,clip_rect,0,0,255);
				}
		// zone border rect
		rectangle_draw_rect.left = 15 + BIG_SPACE_SIZE * (town.in_town_rect.left - cen_x + 4);
		rectangle_draw_rect.right = 15 + BIG_SPACE_SIZE * (town.in_town_rect.right - cen_x + 4 + 1) - 1;
		rectangle_draw_rect.top = 15 + BIG_SPACE_SIZE * (town.in_town_rect.top - cen_y + 4);
		rectangle_draw_rect.bottom = 15 + BIG_SPACE_SIZE * (town.in_town_rect.bottom - cen_y + 4 + 1) - 1;				
		MacInsetRect(&rectangle_draw_rect,3,3);
		put_clipped_rect_in_gworld(hdc,rectangle_draw_rect,clip_rect,255,0,0); 
		
		// description rects
		for (i = 0; i < 16; i++)
			if (town.room_rect[i].right > 0) {
				rectangle_draw_rect.left = 15 + BIG_SPACE_SIZE * (town.room_rect[i].left - cen_x + 4);
				rectangle_draw_rect.right = 15 + BIG_SPACE_SIZE * (town.room_rect[i].right - cen_x + 4 + 1) - 1;
				rectangle_draw_rect.top = 15 + BIG_SPACE_SIZE * (town.room_rect[i].top - cen_y + 4);
				rectangle_draw_rect.bottom = 15 + BIG_SPACE_SIZE * (town.room_rect[i].bottom - cen_y + 4 + 1) - 1;				
				MacInsetRect(&rectangle_draw_rect,4,4);
				put_clipped_rect_in_gworld(hdc,rectangle_draw_rect,clip_rect,0,255,0);
				}
		}
	// Outdoor mode: special encs and other rectangles
	if (editing_town == FALSE) {
		// town entry rects
		for (i = 0; i < 8; i++)
			if ((current_terrain.exit_rects[i].right > 0) && (current_terrain.exit_dests[i] >= 0)) {
				rectangle_draw_rect.left = 15 + BIG_SPACE_SIZE * (current_terrain.exit_rects[i].left - cen_x + 4);
				rectangle_draw_rect.right = 15 + BIG_SPACE_SIZE * (current_terrain.exit_rects[i].right - cen_x + 4 + 1) - 1;
				rectangle_draw_rect.top = 15 + BIG_SPACE_SIZE * (current_terrain.exit_rects[i].top - cen_y + 4);
				rectangle_draw_rect.bottom = 15 + BIG_SPACE_SIZE * (current_terrain.exit_rects[i].bottom - cen_y + 4 + 1) - 1;				
				MacInsetRect(&rectangle_draw_rect,1,1);
				put_clipped_rect_in_gworld(hdc,rectangle_draw_rect,clip_rect,255,0,255);
				}
				
		// special enc rects
		for (i = 0; i < NUM_OUT_PLACED_SPECIALS; i++)
			if (current_terrain.spec_id[i] >= 0) {
				rectangle_draw_rect.left = 15 + BIG_SPACE_SIZE * (current_terrain.special_rects[i].left - cen_x + 4);
				rectangle_draw_rect.right = 15 + BIG_SPACE_SIZE * (current_terrain.special_rects[i].right - cen_x + 4 + 1) - 1;
				rectangle_draw_rect.top = 15 + BIG_SPACE_SIZE * (current_terrain.special_rects[i].top - cen_y + 4);
				rectangle_draw_rect.bottom = 15 + BIG_SPACE_SIZE * (current_terrain.special_rects[i].bottom - cen_y + 4 + 1) - 1;				
				MacInsetRect(&rectangle_draw_rect,1,1);
				put_clipped_rect_in_gworld(hdc,rectangle_draw_rect,clip_rect,200,200,255);
				MacInsetRect(&rectangle_draw_rect,1,1);
				put_clipped_rect_in_gworld(hdc,rectangle_draw_rect,clip_rect,0,0,255);
				}
		
		// description rects
		for (i = 0; i < 8; i++)
			if (current_terrain.info_rect[i].right > 0) {
				rectangle_draw_rect.left = 15 + BIG_SPACE_SIZE * (current_terrain.info_rect[i].left - cen_x + 4);
				rectangle_draw_rect.right = 15 + BIG_SPACE_SIZE * (current_terrain.info_rect[i].right - cen_x + 4 + 1) - 1;
				rectangle_draw_rect.top = 15 + BIG_SPACE_SIZE * (current_terrain.info_rect[i].top - cen_y + 4);
				rectangle_draw_rect.bottom = 15 + BIG_SPACE_SIZE * (current_terrain.info_rect[i].bottom - cen_y + 4 + 1) - 1;				
				MacInsetRect(&rectangle_draw_rect,4,4);
				put_clipped_rect_in_gworld(hdc,rectangle_draw_rect,clip_rect,0,255,0);
				}
		}
				
	SelectObject(hdc,store_bmp);
	DeleteObject(hdc);
	
	// plop ter on screen
	to_rect = whole_area_rect;
	OffsetRect(&to_rect,TER_RECT_UL_X,TER_RECT_UL_Y);
	rect_draw_some_item(ter_draw_gworld,
		whole_area_rect,ter_draw_gworld,to_rect,0,1);			
	

	small_any_drawn = FALSE;
	//if (cur_viewing_mode == 0) 
	//	draw_frames();
	
}

void place_ter_icon_on_tile(short tile_x,short tile_y,short position,short which_icon)
{
	RECT tiny_to = large_edit_ter_rects[tile_x][tile_y];
	tiny_to.right = tiny_to.left + 10;
	tiny_to.bottom = tiny_to.top + 10;
	OffsetRect(&tiny_to,10 * (position / 4) + 1,10 * (position % 4) + 1);
	
	RECT tiny_from = base_small_button_from;
	OffsetRect(&tiny_from,10 * (which_icon % 10),10 * (which_icon / 10));
	rect_draw_some_item(editor_mixed,tiny_from,ter_draw_gworld,tiny_to,0,0);

}



// obj_num is num of object to drawn (in zone's list of objects)
// loc_game_rect is rect on screen of object being drawn
void draw_creature(HDC ter_hdc,HBITMAP store_bmp,short creature_num,location loc_drawn,short in_square_x,short in_square_y)
{
	graphic_id_type a;
	short icon_to_use;
	RECT from_rect,to_rect;
	short r = 0, g = 0, b = 0;
	char str[256];
	
	if (town.creatures[creature_num].exists() == FALSE)
		return;
		
	if (same_point(town.creatures[creature_num].start_loc,loc_drawn)) {
		RECT base_rect = large_edit_ter_rects[in_square_x][in_square_y];
		a = scen_data.scen_creatures[town.creatures[creature_num].number].char_graphic;

		from_rect = get_template_from_rect(0,0);
		MacInsetRect(&from_rect,3,6);
		RECT to_rect = from_rect;
		CenterRectInRect(&to_rect,&base_rect);
		
		short obj_index = safe_get_index_of_sheet(&a);
		if (obj_index < 0) {
			cant_draw_graphics_error(a,"Error was for creature type",town.creatures[creature_num].number);
			}		
			else rect_draw_some_item(graphics_library[obj_index],
				from_rect,ter_draw_gworld,to_rect,0,0);

		if (town.creatures[creature_num].start_attitude >= 4)
			r = 255;
			else if (town.creatures[creature_num].start_attitude < 3)
				b = 255;
		if (town.creatures[creature_num].hidden_class > 0) 
			g = 255;

		SelectObject(ter_hdc,DibBitmapHandle(ter_draw_gworld));
		put_rect_in_gworld(ter_hdc,to_rect,
		  r,g,b);

		// do facing
		RECT facing_to_rect = to_rect;
		MacInsetRect(&facing_to_rect,1,1);
		switch (town.creatures[creature_num].facing) {
			case 0: MacInsetRect(&facing_to_rect,3,0); facing_to_rect.bottom = facing_to_rect.top + 2; break;
			case 1: MacInsetRect(&facing_to_rect,0,3); facing_to_rect.right = facing_to_rect.left + 2; break;
			case 2: MacInsetRect(&facing_to_rect,3,0); facing_to_rect.top = facing_to_rect.bottom - 2; break;
			case 3: MacInsetRect(&facing_to_rect,0,3); facing_to_rect.left = facing_to_rect.right - 2; break;
			}
		put_rect_in_gworld(ter_hdc,facing_to_rect,
		  0,0,0);
		SelectObject(ter_hdc,store_bmp);
		  
		// Labels for wandering and hidden
		if (town.creatures[creature_num].hidden_class > 0) {
			sprintf(str,"H");
			}
		}

}

void draw_item(HDC ter_hdc,HBITMAP store_bmp,short item_num,location loc_drawn,short in_square_x,short in_square_y)
{
	graphic_id_type a;
	short icon_to_use;
	RECT from_rect,to_rect;
	
		
	if (town.preset_items[item_num].exists() == FALSE)
		return;
		
	if (same_point(town.preset_items[item_num].item_loc,loc_drawn)) {
		RECT to_rect = large_edit_ter_rects[in_square_x][in_square_y];
		MacInsetRect(&to_rect,10,10);
		OffsetRect(&to_rect, town.preset_items[item_num].item_shift.x,town.preset_items[item_num].item_shift.y);
		
		a = scen_data.scen_items[town.preset_items[item_num].which_item].item_floor_graphic;

		icon_to_use = scen_data.scen_items[town.preset_items[item_num].which_item].inven_icon;

		SetRect(&from_rect,1 + 29 * (icon_to_use % 10),
		  1 + 29 * (icon_to_use / 10),
		  1 + 29 * (icon_to_use % 10) + 28,
		  1 + 29 * (icon_to_use / 10) + 28);
		
		short obj_index = safe_get_index_of_sheet(&a);
		if (obj_index < 0) {
			cant_draw_graphics_error(a,"Error was for item type",town.preset_items[item_num].which_item);
			SelectObject(ter_hdc,DibBitmapHandle(ter_draw_gworld));
			put_rect_in_gworld(ter_hdc,to_rect,0,0,0);
			SelectObject(ter_hdc,store_bmp);
			return;
			}		
		
		rect_draw_some_item(graphics_library[obj_index],
			from_rect,ter_draw_gworld,to_rect,0,0);

		SelectObject(ter_hdc,DibBitmapHandle(ter_draw_gworld));
		put_rect_in_gworld(ter_hdc,to_rect,0,0,0);
		SelectObject(ter_hdc,store_bmp);
		}

}

void draw_ter_script(short script_num,location loc_drawn,short in_square_x,short in_square_y)
{
	short icon_to_use;
	RECT from_rect,to_rect;
	RECT ter_script_icon_from = {100,103,120,123}; /**/
	
	if (town.ter_scripts[script_num].exists == FALSE)
		return;
		
	if (same_point(town.ter_scripts[script_num].loc,loc_drawn)) {
		RECT to_rect = large_edit_ter_rects[in_square_x][in_square_y];
		to_rect.left = to_rect.right - 20;
		to_rect.bottom = to_rect.top + 20;
		
		rect_draw_some_item(editor_mixed,
			ter_script_icon_from,ter_draw_gworld,to_rect,0,0);

		}

}

Boolean place_terrain_icon_into_ter_small(graphic_id_type icon,short in_square_x,short in_square_y)
{
	RECT to_rect = small_edit_ter_rects[in_square_x][in_square_y];
	RECT from_rect;

	graphic_id_type a = icon;

	short index = safe_get_index_of_sheet(&a);
	if (index < 0) {
		//cant_draw_graphics_error(a);
		return FALSE;	
		}		
	SetRect(&from_rect,1 + (TER_BUTTON_SIZE + 1) * (a.which_icon % 10),1 + (TER_BUTTON_SIZE + 1) * (a.which_icon / 10),
	  1 + (TER_BUTTON_SIZE + 1) * (a.which_icon % 10) + TER_BUTTON_SIZE,1 + (TER_BUTTON_SIZE + 1) * (a.which_icon / 10) + TER_BUTTON_SIZE);

	RECT buffer_to_rect = to_rect;
	ZeroRectCorner(&buffer_to_rect);
	rect_draw_some_item(graphics_library[index],
		from_rect,ter_resize_buffer_gworld,buffer_to_rect,0,0);
	rect_draw_some_item(ter_resize_buffer_gworld,
		buffer_to_rect,ter_draw_gworld,to_rect,1,0);

	return TRUE;
}



void reset_small_drawn()
{
	for (short q = 0; q < 64; q++) 
		for (short r = 0; r < 64; r++) {
			small_what_drawn[q][r] = small_what_floor_drawn[q][r] = -1;
			}
}

void draw_ter_small()
{
	short q,r,x,y,i,small_i;
	location which_pt,where_draw;
	RECT draw_rect;	
	short t_to_draw,floor_to_draw;
	RECT source_rect,tiny_to,tiny_to_base = {29,37,36,44},tiny_from,from_rect,to_rect; /**/
	graphic_id_type a;
	short index;
	HDC hdc;
	HBITMAP store_bmp;
	
	// first, clear area not drawn on
	if ((editing_town == FALSE) || (town_type > 0)) {
		RECT fill_area_rect = {small_edit_ter_rects[0][0].left,small_edit_ter_rects[0][0].top,
			small_edit_ter_rects[63][63].right,small_edit_ter_rects[63][63].bottom}; /**/
		fill_area_rect.left = small_edit_ter_rects[((editing_town) ? max_dim[town_type] : 48)][0].left;
 		paint_pattern(ter_draw_gworld,0,fill_area_rect,2);
		fill_area_rect.left = 0;
		fill_area_rect.top = small_edit_ter_rects[0][((editing_town) ? max_dim[town_type] : 48)].top;	
 		paint_pattern(ter_draw_gworld,0,fill_area_rect,2);
		}
	
	RECT whole_area_rect;
	SetRect(&whole_area_rect,small_edit_ter_rects[0][0].left,small_edit_ter_rects[0][0].top,
		small_edit_ter_rects[MAX_TOWN_SIZE - 1][MAX_TOWN_SIZE - 1].right,small_edit_ter_rects[MAX_TOWN_SIZE - 1][MAX_TOWN_SIZE - 1].bottom);
	
	ZeroRectCorner(&whole_area_rect);
	
	hdc = CreateCompatibleDC(main_dc);
	SetBkMode(hdc,TRANSPARENT);
	SelectObject(hdc,bold_font);
	store_bmp = (HBITMAP) SelectObject(hdc,DibBitmapHandle(ter_draw_gworld));

	for (q = 0; q < ((editing_town) ? max_dim[town_type] : 48); q++) 
		for (r = 0; r < ((editing_town) ? max_dim[town_type] : 48); r++) {
			where_draw.x = q; where_draw.y = r;
	
			t_to_draw = (editing_town) ? t_d.terrain[q][r] : current_terrain.terrain[q][r];		
			floor_to_draw = (editing_town) ? t_d.floor[q][r] : current_terrain.floor[q][r];		
			
			if ((small_any_drawn == FALSE) || (small_what_drawn[q][r] != t_to_draw) || 
				(small_what_floor_drawn[q][r] != floor_to_draw)) { 
					
				// draw floor
				a = scen_data.scen_floors[floor_to_draw].ed_pic;
				if (a.not_legit()) {
					//fill_rect_in_gworld(ter_draw_gworld,small_edit_ter_rects[q][r],230,230,230);
					fill_rect_in_gworld(hdc,small_edit_ter_rects[q][r],230,230,230);
					}
					else {
						SelectObject(hdc,store_bmp);
						if (place_terrain_icon_into_ter_small(a,q,r) == FALSE)
							cant_draw_graphics_error(a,"Error was for floor type",floor_to_draw);
						SelectObject(hdc,DibBitmapHandle(ter_draw_gworld));
						}
						
				// draw terrain
				if (t_to_draw > 0) {
					SelectObject(hdc,store_bmp);
					a = scen_data.scen_ter_types[t_to_draw].ed_pic;
					if (a.not_legit() == FALSE) 
						if (place_terrain_icon_into_ter_small(a,q,r) == FALSE)
							cant_draw_graphics_error(a,"Error was for terrain type",t_to_draw);
					SelectObject(hdc,DibBitmapHandle(ter_draw_gworld));
					}

				small_what_drawn[q][r] = t_to_draw;
				small_what_floor_drawn[q][r] = floor_to_draw;
				}

			// draw creatures
			if ((editing_town) && (hintbook_mode == FALSE)) {
				for (i = 0; i < NUM_TOWN_PLACED_CREATURES; i++)
					if ((town.creatures[i].exists()) && 
					  (town.creatures[i].start_loc.x == q) && (town.creatures[i].start_loc.y == r)) {
					  	to_rect = small_edit_ter_rects[q][r];
					  	MacInsetRect(&to_rect,1,1);
						if (town.creatures[i].start_attitude < 3)
							put_rect_in_gworld(hdc,to_rect,0,255,0);
							else if (town.creatures[i].start_attitude > 3)
								put_rect_in_gworld(hdc,to_rect,255,0,0);
								else put_rect_in_gworld(hdc,to_rect,0,0,255);
						
						}	
				}
			}

	small_any_drawn = TRUE;

	 put_rect_in_gworld( hdc,terrain_rect_gr_size,0,0,0);

	// draw grid of lines
	if (hintbook_mode == FALSE) {
		for (i = 1; i < 64; i++) {
			if (i % 10 == 0) {
				put_line_in_gworld(hdc,0,SMALL_SPACE_SIZE * i,SMALL_SPACE_SIZE * MAX_TOWN_SIZE - 1,SMALL_SPACE_SIZE * i,3 * 8,3 * 8,6 * 8);
				}
			if (i % 10 == 5) {
				put_line_in_gworld(hdc,0,SMALL_SPACE_SIZE * i,SMALL_SPACE_SIZE * MAX_TOWN_SIZE - 1,SMALL_SPACE_SIZE * i,10 * 8,10 * 8,20 * 8);
				}
			}
		for (i = 1; i < 64; i++) {
			if (i % 10 == 0) {
				put_line_in_gworld(hdc,SMALL_SPACE_SIZE * i,0,SMALL_SPACE_SIZE * i,SMALL_SPACE_SIZE * MAX_TOWN_SIZE - 1,3 * 8,3 * 8,6 * 8);
				}
			if (i % 10 == 5) {
				put_line_in_gworld(hdc,SMALL_SPACE_SIZE * i,0,SMALL_SPACE_SIZE * i,SMALL_SPACE_SIZE * MAX_TOWN_SIZE - 1,10 * 8,10 * 8,20 * 8);
				}
			}
		

		}

	SelectObject(hdc,store_bmp);
	DeleteObject(hdc);
	
	// plop ter on screen
	to_rect = whole_area_rect;
	OffsetRect(&to_rect,TER_RECT_UL_X,TER_RECT_UL_Y);
	rect_draw_some_item(ter_draw_gworld,
		whole_area_rect,ter_draw_gworld,to_rect,0,1);			

}


void draw_terrain()
{
	
	if (cur_viewing_mode == 0) 
		draw_ter_large();
		
	if (cur_viewing_mode == 1) 
		draw_ter_small();

	place_left_text();
	
	place_right_buttons(0);

	//rect_draw_some_item(ter_draw_gworld,terrain_rect,ter_draw_gworld,world_screen,0,1);
}

// Takes care of everything on the left side of the screen that isn't terrain. 
// Cleans up screen with background and puts 8 text strings.
void place_left_text()
{
	RECT to_rect;
	char draw_str[256];
	
	if (cur_viewing_mode == 1) 
		return;

	for (short i = 0; i < 10; i++)
 		paint_pattern(NULL,1,left_text_lines[i],0);

	SelectObject(main_dc,bold_font);
	
	if (file_is_loaded == FALSE) {
		sprintf((char *) draw_str,"No Scenario Loaded"); 
		char_win_draw_string(main_dc,left_text_lines[0],(char *) draw_str,2,10);		
		return;
		}
		
	if (editing_town) {
		// Erase and draw bottom text strs
		if ((selected_item_number >= 7000) && (selected_item_number < 7000 + NUM_TOWN_PLACED_CREATURES)) {
			sprintf((char *) draw_str,"Creature %d: %s",selected_item_number % 1000 + 6,
				scen_data.scen_creatures[town.creatures[selected_item_number % 1000].number].name); 
			char_win_draw_string(main_dc,left_text_lines[0],(char *) draw_str,2,10);		

			sprintf((char *) draw_str,"  Edit This Creature  (Type %d, L%d)",
				town.creatures[selected_item_number % 1000].number,
				scen_data.scen_creatures[town.creatures[selected_item_number % 1000].number].level); 
			char_win_draw_string(main_dc,left_text_lines[1],(char *) draw_str,2,10);	

			if (strlen(town.creatures[selected_item_number % 1000].char_script) <= 0)
				sprintf((char *) draw_str,"  Script: Default");
				else sprintf((char *) draw_str,"  Script: %s",
			  	 town.creatures[selected_item_number % 1000].char_script); 
			char_win_draw_string(main_dc,left_text_lines[2],(char *) draw_str,2,10);		

			sprintf((char *) draw_str,"  Attitude: %s",
			  attitude_types[town.creatures[selected_item_number % 1000].start_attitude - 2]); 
			char_win_draw_string(main_dc,left_text_lines[3],(char *) draw_str,2,10);		
			
			sprintf((char *) draw_str,"  Character ID: %d",
			   town.creatures[selected_item_number % 1000].character_id); 
			char_win_draw_string(main_dc,left_text_lines[4],(char *) draw_str,2,10);		

			sprintf((char *) draw_str,"  Hidden Class: %d",
			  town.creatures[selected_item_number % 1000].hidden_class); 
			char_win_draw_string(main_dc,left_text_lines[5],(char *) draw_str,2,10);		

			if (town.creatures[selected_item_number % 1000].extra_item == 0)
				town.creatures[selected_item_number % 1000].extra_item = -1;
			
			if (town.creatures[selected_item_number % 1000].extra_item < 0)
				sprintf((char *) draw_str,"  Drop Item 1: None");
				else sprintf((char *) draw_str,"  Drop Item 1: %s %%%d",
				  scen_data.scen_items[town.creatures[selected_item_number % 1000].extra_item].full_name,
				  town.creatures[selected_item_number % 1000].extra_item_chance_1); 
			char_win_draw_string(main_dc,left_text_lines[6],(char *) draw_str,2,10);		

			if (town.creatures[selected_item_number % 1000].extra_item_2 == 0)
				town.creatures[selected_item_number % 1000].extra_item_2 = -1;

			if (town.creatures[selected_item_number % 1000].extra_item_2 < 0)
				sprintf((char *) draw_str,"  Drop Item 2: None");
				else sprintf((char *) draw_str,"  Drop Item 2: %s %%%d",
				  scen_data.scen_items[town.creatures[selected_item_number % 1000].extra_item_2].full_name,
				  town.creatures[selected_item_number % 1000].extra_item_chance_2); 
			char_win_draw_string(main_dc,left_text_lines[7],(char *) draw_str,2,10);		

			sprintf((char *) draw_str,"  Personality: %d",
			   town.creatures[selected_item_number % 1000].personality); 
			char_win_draw_string(main_dc,left_text_lines[8],(char *) draw_str,2,10);		

			sprintf((char *) draw_str,"  Facing: %s",
			  facings[town.creatures[selected_item_number % 1000].facing]); 
			char_win_draw_string(main_dc,left_text_lines[9],(char *) draw_str,2,10);		
				
			}
		if ((selected_item_number >= 9000) && (selected_item_number < 9000 + NUM_TER_SCRIPTS)) {
			sprintf((char *) draw_str,"Terrain Script %d:",selected_item_number % 1000); 
			char_win_draw_string(main_dc,left_text_lines[0],(char *) draw_str,2,10);		

			sprintf((char *) draw_str,"  Script: %s",
			  	 town.ter_scripts[selected_item_number % 1000].script_name); 
			char_win_draw_string(main_dc,left_text_lines[1],(char *) draw_str,2,10);		
			for (short i = 0; i < 8; i++) {
				sprintf((char *) draw_str,"  Memory Cell %d: %d",
				   i,town.ter_scripts[selected_item_number % 1000].memory_cells[i]); 
				char_win_draw_string(main_dc,left_text_lines[i + 2],(char *) draw_str,2,10);		
				}
			/*
			sprintf((char *) draw_str,"  Edit This Creature"); 
			char_win_draw_string(mainPtr,left_text_lines[1],(char *) draw_str,2,10);	

			if (strlen(town.creatures[selected_item_number % 1000].char_script) <= 0)
				sprintf((char *) draw_str,"  Script: Default");
				else sprintf((char *) draw_str,"  Script: %s",
			  	 town.creatures[selected_item_number % 1000].char_script); 
			char_win_draw_string(mainPtr,left_text_lines[2],(char *) draw_str,2,10);		

			sprintf((char *) draw_str,"  Attitude: %s",
			  attitude_types[town.creatures[selected_item_number % 1000].start_attitude - 2]); 
			char_win_draw_string(mainPtr,left_text_lines[3],(char *) draw_str,2,10);		
			
			sprintf((char *) draw_str,"  Character ID: %d",
			   town.creatures[selected_item_number % 1000].character_id); 
			char_win_draw_string(mainPtr,left_text_lines[4],(char *) draw_str,2,10);		

			sprintf((char *) draw_str,"  Hidden Class: %d",
			  town.creatures[selected_item_number % 1000].hidden_class); 
			char_win_draw_string(mainPtr,left_text_lines[5],(char *) draw_str,2,10);		

			if (town.creatures[selected_item_number % 1000].extra_item < 0)
				sprintf((char *) draw_str,"  Drop Item 1: None");
				else sprintf((char *) draw_str,"  Drop Item 1: %s %%%d",
				  scen_data.scen_items[town.creatures[selected_item_number % 1000].extra_item].full_name,
				  town.creatures[selected_item_number % 1000].extra_item_chance_1); 
			char_win_draw_string(mainPtr,left_text_lines[6],(char *) draw_str,2,10);		

			if (town.creatures[selected_item_number % 1000].extra_item_2 < 0)
				sprintf((char *) draw_str,"  Drop Item 2: None");
				else sprintf((char *) draw_str,"  Drop Item 2: %s %%%d",
				  scen_data.scen_items[town.creatures[selected_item_number % 1000].extra_item_2].full_name,
				  town.creatures[selected_item_number % 1000].extra_item_chance_2); 
			char_win_draw_string(mainPtr,left_text_lines[7],(char *) draw_str,2,10);		

			sprintf((char *) draw_str,"  Personality: %d",
			   town.creatures[selected_item_number % 1000].personality); 
			char_win_draw_string(mainPtr,left_text_lines[8],(char *) draw_str,2,10);		

			sprintf((char *) draw_str,"  Facing: %s",
			  facings[town.creatures[selected_item_number % 1000].facing]); 
			char_win_draw_string(mainPtr,left_text_lines[9],(char *) draw_str,2,10);		
			*/
			}
		if ((selected_item_number >= 11000) && (selected_item_number < 11000 + NUM_TOWN_PLACED_ITEMS)) {
			sprintf((char *) draw_str,"Item %d",selected_item_number % 1000); 
			char_win_draw_string(main_dc,left_text_lines[0],(char *) draw_str,2,10);		
			sprintf((char *) draw_str,"  %s",
			  scen_data.scen_items[town.preset_items[selected_item_number % 1000].which_item].full_name); 
			char_win_draw_string(main_dc,left_text_lines[1],(char *) draw_str,2,10);		
			if (scen_data.scen_items[town.preset_items[selected_item_number % 1000].which_item].charges > 0) {
				sprintf((char *) draw_str,"  Charges/Amount: %d",
				  town.preset_items[selected_item_number % 1000].charges); 
				char_win_draw_string(main_dc,left_text_lines[2],(char *) draw_str,2,10);		
				}
			if (town.preset_items[selected_item_number % 1000].properties & 2)
				sprintf((char *) draw_str,"  Property");
				else sprintf((char *) draw_str,"  Not Property");
			char_win_draw_string(main_dc,left_text_lines[3],(char *) draw_str,2,10);		
			if (town.preset_items[selected_item_number % 1000].properties & 4)
				sprintf((char *) draw_str,"  Contained");
				else sprintf((char *) draw_str,"  Not Contained");
			char_win_draw_string(main_dc,left_text_lines[4],(char *) draw_str,2,10);		
			sprintf((char *) draw_str,"  Drawing Shift X: %d",
			  town.preset_items[selected_item_number % 1000].item_shift.x); 
			char_win_draw_string(main_dc,left_text_lines[5],(char *) draw_str,2,10);		
			sprintf((char *) draw_str,"  Drawing Shift Y: %d",
			  town.preset_items[selected_item_number % 1000].item_shift.y); 
			char_win_draw_string(main_dc,left_text_lines[6],(char *) draw_str,2,10);		
			}
		if (selected_item_number < 0) {
			sprintf((char *) draw_str,"Editing Town/Dungeon %d",cur_town); 
			char_win_draw_string(main_dc,left_text_lines[0],(char *) draw_str,2,10);		
			sprintf((char *) draw_str,"  %s",town.town_name); 
			char_win_draw_string(main_dc,left_text_lines[1],(char *) draw_str,2,10);		
			//sprintf((char *) draw_str,"  Section X = %d, Y = %d",cur_out.x,cur_out.y); 
			//char_win_draw_string(mainPtr,left_text_lines[2],(char *) draw_str,2,10);		
			}
		}
		else {
			sprintf((char *) draw_str,"Editing Outdoors"); 
			char_win_draw_string(main_dc,left_text_lines[0],(char *) draw_str,2,10);		
			sprintf((char *) draw_str,"  %s",current_terrain.name); 
			char_win_draw_string(main_dc,left_text_lines[1],(char *) draw_str,2,10);		
			sprintf((char *) draw_str,"  Section X = %d, Y = %d",cur_out.x,cur_out.y); 
			char_win_draw_string(main_dc,left_text_lines[2],(char *) draw_str,2,10);		
			}
}


// Draws the whole or part of the button and location area to right
// mode: 0 - draw whole thing
//		 1 - just location
void place_right_buttons(short mode)
{
	RECT to_rect;
	RECT whole_palette_from = {0,0,201,86}; /**/
	char draw_str[256];

	HBITMAP store_bmp;
	HDC hdc;

	for (short i = 0; i < 5; i++) {
 		paint_pattern(terrain_buttons_gworld,0,right_text_lines[i],2);
		}
	
	if (file_is_loaded == FALSE) {
		to_rect = terrain_buttons_rect;
		OffsetRect(&to_rect,RIGHT_BUTTONS_X_SHIFT,0);
		rect_draw_some_item(terrain_buttons_gworld,terrain_buttons_rect,
			terrain_buttons_gworld,to_rect,0,1); 
		return;
		}

	hdc = CreateCompatibleDC(main_dc);
	SetBkMode(hdc,TRANSPARENT);
	SelectObject(hdc,bold_font);
	store_bmp = (HBITMAP) SelectObject(hdc,DibBitmapHandle(terrain_buttons_gworld));
	
	switch (current_drawing_mode) {
		case 0: sprintf((char *) draw_str,"Drawing mode: FLOORS"); break;
		case 1: sprintf((char *) draw_str,"Drawing mode: TERRAIN"); break;
		case 2: sprintf((char *) draw_str,"Drawing mode: HEIGHT"); break;
		}
	char_win_draw_string(hdc,right_text_lines[0],(char *) draw_str,2,12);
	
	sprintf((char *) draw_str,"Center: x = %d, y = %d ",cen_x,cen_y);
	char_win_draw_string(hdc,right_text_lines[1],(char *) draw_str,2,12);

	if (current_drawing_mode == 2) {
		if (current_height_mode == 0)
			char_win_draw_string(hdc,right_text_lines[2],
			  "Automatic Hills: OFF",2,12);
			else char_win_draw_string(hdc,right_text_lines[2],
			  "Automatic Hills: ON",2,12);
		}
		
	char_win_draw_string(hdc,right_text_lines[3],(char *) current_string,2,12);
	char_win_draw_string(hdc,right_text_lines[4],(char *) current_string2,2,12);
		
	// palette buttons
	for (short i = 0; i < 8; i++)
		for (short j = 0; j < ((editing_town == TRUE) ? 6 : 3); j++) {
			//RECT from_rect = {PALETTE_BUT_HEIGHT * j,PALETTE_BUT_WIDTH * 1,
			//	PALETTE_BUT_HEIGHT * (j + 1),PALETTE_BUT_WIDTH * (i + 1)};
			RECT to_rect = palette_buttons[i][j];
			RECT from_rect = to_rect;
			ZeroRectCorner(&from_rect);
			OffsetRect(&from_rect,PALETTE_BUT_WIDTH * i,PALETTE_BUT_HEIGHT * j);
			to_rect.right++;
			from_rect.right++;
			
			rect_draw_some_item(editor_mixed,
				from_rect,terrain_buttons_gworld,to_rect,0,0);
			
			}

		
	// place buttons on screen
	to_rect = terrain_buttons_rect;
	OffsetRect(&to_rect,RIGHT_BUTTONS_X_SHIFT,0);
	SelectObject(hdc,store_bmp);
	rect_draw_some_item(terrain_buttons_gworld,terrain_buttons_rect,
		terrain_buttons_gworld,to_rect,0,1);
	SelectObject(hdc,DibBitmapHandle(terrain_buttons_gworld));

	// draw frames around selected ter
	short selected_ter = -1;
	switch (current_drawing_mode) {
		case 0: selected_ter = current_floor_drawn; to_rect = terrain_rects[selected_ter]; break;
		case 1: 
		case 2: selected_ter = current_terrain_drawn; 
			short draw_position = selected_ter - 12 * GetControlValue(right_sbar);
			if (draw_position != minmax(0,263,draw_position))
				selected_ter = -1;
				else to_rect = terrain_rects[draw_position];
			break;
		}	
	if (selected_ter >= 0) {
		OffsetRect(&to_rect,RIGHT_BUTTONS_X_SHIFT,0);
		MacInsetRect(&to_rect,-1,-1);
		put_rect_on_screen(main_dc,to_rect,0,0,0);
		}
	SelectObject(hdc,store_bmp);
	DeleteObject(hdc);

}

void set_string(char *string,char *string2)
{
	strcpy((char *)current_string,string);

	strcpy((char *)current_string2,string2);

	place_right_buttons(0);
}

Boolean container_there(location l)
{

	short ter;
	terrain_type_type terrain;
	
	if (editing_town == FALSE)
		return FALSE;
	terrain = scen_data.scen_ter_types[t_d.terrain[l.x][l.y]];
	if (terrain.special == 40)
		return TRUE;
	if (is_barrel(l.x,l.y) == TRUE)
		return TRUE;
	if (is_crate(l.x,l.y) == TRUE)
		return TRUE;

	return 0;		
}

void win_draw_string_outline(HDC dest_hdc,RECT dest_rect,char *str,short mode,short line_height)
{

	SetTextColor(dest_hdc,RGB(255,255,255));
	OffsetRect(&dest_rect,1,0);
	char_win_draw_string(dest_hdc,dest_rect,str,mode,line_height);
	OffsetRect(&dest_rect,-1,1);
	char_win_draw_string(dest_hdc,dest_rect,str,mode,line_height);
	OffsetRect(&dest_rect,-1,-1);
	char_win_draw_string(dest_hdc,dest_rect,str,mode,line_height);
	OffsetRect(&dest_rect,1,-1);
	char_win_draw_string(dest_hdc,dest_rect,str,mode,line_height);
	OffsetRect(&dest_rect,0,1);
	
	SetTextColor(dest_hdc,RGB(0,0,0));
	char_win_draw_string(dest_hdc,dest_rect,str,mode,line_height);

}

void char_win_draw_string(HDC dest_window,RECT dest_rect,char *str,short mode,short line_height)
{
	char store_s[256];
	
	strcpy((char *) store_s,str);
	win_draw_string( dest_window, dest_rect,store_s, mode, line_height);

}

// mode: 0 - align up and left, 1 - center on one line
// str is a c string, 256 characters
// uses current font
void win_draw_string(HDC dest_hdc,RECT dest_rect,char *str,short mode,short line_height)
{
	short i;

// this will need formatting for '|' line breaks
	for (i = 0; i < 256; i++)  {
		if (str[i] == '|')
			str[i] = 13;
		if (str[i] == '_')
      	str[i] = 34;
		}
	// if dest is main window, add ulx, uly
	if (dest_hdc == main_dc)
		OffsetRect(&dest_rect,ulx,uly);
	switch (mode) {
		case 0:
         dest_rect.bottom += 6;
			DrawText(dest_hdc,str,strlen((char *)str),&dest_rect,DT_LEFT | DT_WORDBREAK); break;
		case 1:
			dest_rect.bottom += 6; dest_rect.top -= 6;
			DrawText(dest_hdc,str,strlen((char *)str),&dest_rect,
			DT_CENTER | DT_VCENTER | DT_NOCLIP | DT_SINGLELINE); break;
		case 2: case 3:
			dest_rect.bottom += 6; dest_rect.top -= 6;
			DrawText(dest_hdc,str,strlen((char *)str),&dest_rect,
			DT_LEFT | DT_VCENTER | DT_NOCLIP | DT_SINGLELINE); break;
		}
	// not yet done adjusts for 1, 2, 3
	
}

void c2p(char *str) 
{

}

void p2c(char *str)
{

}

// i,j is a STR# resource.
// If i < 0, get instead other strings
//   -1 - creature types
//   -2 - item types
//   -3 - buttons
//   -4 - terrain
//   -6 - floor
void get_str(char *str,short i, short j)
{

	if (i == -1) {
		sprintf((char *) str,"%s (L%d)",scen_data.scen_creatures[j].name,
			scen_data.scen_creatures[j].level);
		return;
		}
	if (i == -2) {
		strcpy((char *) str,scen_data.scen_items[j].full_name);
		return;
		}
	if (i == -3) {
		strcpy((char *) str,button_strs[available_dlog_buttons[j]]);
		return;
		}

	if (i == -4) {
		strcpy((char *) str,scen_data.scen_ter_types[j].ter_name);
		return;
		}
	if (i == -6) {
		strcpy((char *) str,scen_data.scen_floors[j].floor_name);
		return;
		}
	
	GetIndString(str, i, j);
	p2c(str);
}

short string_length(char *str,HDC hdc)
{
	short text_len[257];
	short total_width = 0,i,len;
	char p_str[256];
	
	for (i = 0; i < 257; i++)
		text_len[i]= 0;
	
	strcpy((char *) p_str,str);
	MeasureText(256,p_str,text_len,hdc);
	len = strlen((char *)str);

	//print_nums(text_len[1],text_len[2],text_len[3]);
   //print_nums(text_len[10],text_len[20],text_len[30]);
	for (i = 0; i < 257; i++)
		if ((text_len[i] > total_width) && (i <= len))
			total_width = text_len[i];
	return total_width;
}

Boolean spot_in_rect(location l,RECT r)
{
	if ((l.x < r.left) || (l.x > r.right) || (l.y < r.top) || (l.y > r.bottom))
		return FALSE;
	return TRUE;
}

Boolean refresh_graphics_library()
{
	for (short i = 0; i < num_sheets_in_library; i++) {
		delete_graphic(&graphics_library[i]);
		}
	num_sheets_in_library = 0;

	return TRUE;
}


// Adds a new sheet into library. Returns FALSE if at end of procedure sheet
// is not safely there.
// Not e that the which_icon field of new_sheet is ignored.
Boolean load_sheet_into_library(graphic_id_type *new_sheet)
{
	// error checking
	if (new_sheet->not_legit())
		return FALSE;
	
	// first, make sure new sheet isn't already in there
	if (get_index_of_sheet(new_sheet) >= 0)
		return TRUE;
	
	if (num_sheets_in_library >= MAX_NUM_SHEETS_IN_LIBRARY)
		return FALSE;
		
	graphics_library[num_sheets_in_library] = NULL;
	graphics_library[num_sheets_in_library] = load_pict(new_sheet->which_sheet);	
	if (graphics_library[num_sheets_in_library] == NULL)
		return FALSE;
		
	graphics_library_index[num_sheets_in_library] = *new_sheet;

	// modify graphics ccording to flag
	
	num_sheets_in_library++;
	return TRUE;
	
}

// Returns the number of the sheet witht he right characteristics.
// Returns -1 if not there.
short get_index_of_sheet(graphic_id_type *sheet)
{
	for (short i = 0; i < num_sheets_in_library; i++)
		if ((graphics_library[i] != NULL) && ((graphics_library_index[i].which_sheet) == (sheet->which_sheet)) &&
		((graphics_library_index[i].graphic_adjust) == (sheet->graphic_adjust)))
			return i;
	return -1;
}

// like get_index_of_sheet, but, if it's not there, loads it and then gets index. returns -1 if load fails.
// Returning -1 from here VERY bad karma.
short safe_get_index_of_sheet(graphic_id_type *sheet)
{
	if (sheet->not_legit())
		return -1;
		
	short index = get_index_of_sheet(sheet); 
	if (index < 0) {
		if (load_sheet_into_library(sheet) == FALSE) {
			refresh_graphics_library();
			if (load_sheet_into_library(sheet) == FALSE)
				return -1;
			}
		index = get_index_of_sheet(sheet);
		if (index < 0)
			return -1;
		}
	return index;
}

void put_rect_in_gworld(HDC hdc,RECT rect,short r,short g, short b)
{
	HPEN hpen,old_pen;

	if (hdc == NULL) {
		beep();
		return;
		}
	rect.right--;
	rect.bottom--;
	hpen = CreatePen(PS_SOLID,1,RGB(r,g,b));
	old_pen = (HPEN) SelectObject(hdc,hpen);
	MoveToEx(hdc,rect.left,rect.top,NULL);
	LineTo(hdc,rect.right,rect.top);
	LineTo(hdc,rect.right,rect.bottom);
	LineTo(hdc,rect.left,rect.bottom);
	LineTo(hdc,rect.left,rect.top);
	SelectObject(hdc,old_pen);
	DeleteObject(hpen);
}

void fill_rect_in_gworld(HDC line_gworld,RECT to_rect,short r,short g, short b)
{
	//to_rect.right--;
	//to_rect.bottom--;
	PaintRect(&to_rect,line_gworld,r,g,b);
}

void put_line_in_gworld(HDC line_gworld,short from_x,short from_y,short to_x,short to_y,short r,short g, short b)
{
	HPEN hpen,old_pen;

	if (line_gworld == NULL) {
		beep();
		return;
		}
	hpen = CreatePen(PS_SOLID,1,RGB(r,g,b));
	old_pen = (HPEN) SelectObject(line_gworld,hpen);
	MoveToEx(line_gworld,from_x,from_y,NULL);
	LineTo(line_gworld,to_x,to_y);
	SelectObject(line_gworld,old_pen);
	DeleteObject(hpen);
}

void put_rect_on_screen(HDC win,RECT to_rect,short r,short g, short b)
{
	put_rect_in_gworld(win,to_rect,r,g,b);
}

void put_line_on_screen(HDC win,short from_x,short from_y,short to_x,short to_y,short r,short g, short b)
{
	put_line_in_gworld(win,from_x,from_y,to_x,to_y,r,g,b);
}

void put_clipped_rect_on_screen(HDC win,RECT to_rect,RECT clip_rect,short r,short g, short b)
{
	if (rects_touch(&to_rect,&clip_rect) == FALSE)
		return;

	if ((to_rect.top >= clip_rect.top) && (to_rect.top < clip_rect.bottom))
		put_line_on_screen(win,max(to_rect.left,clip_rect.left),to_rect.top,
		  min(to_rect.right,clip_rect.right),to_rect.top,r,g,b);
	if ((to_rect.bottom >= clip_rect.top) && (to_rect.bottom < clip_rect.bottom))
		put_line_on_screen(win,max(to_rect.left,clip_rect.left),to_rect.bottom,
		  min(to_rect.right,clip_rect.right),to_rect.bottom,r,g,b);
	
	if ((to_rect.left >= clip_rect.left) && (to_rect.left < clip_rect.right))
		put_line_on_screen(win,to_rect.left,max(to_rect.top,clip_rect.top),
		  to_rect.left,min(to_rect.bottom,clip_rect.bottom),r,g,b);
	if ((to_rect.right >= clip_rect.left) && (to_rect.right < clip_rect.right))
		put_line_on_screen(win,to_rect.right,max(to_rect.top,clip_rect.top),
		  to_rect.right,min(to_rect.bottom,clip_rect.bottom),r,g,b);

}

void put_clipped_rect_in_gworld(HDC line_gworld,RECT to_rect,RECT clip_rect,short r,short g, short b)
{
	if (rects_touch(&to_rect,&clip_rect) == FALSE)
		return;
	if ((to_rect.top >= clip_rect.top) && (to_rect.top < clip_rect.bottom))
		put_line_in_gworld(line_gworld,max(to_rect.left,clip_rect.left),to_rect.top,
		  min(to_rect.right,clip_rect.right),to_rect.top,r,g,b);
	if ((to_rect.bottom >= clip_rect.top) && (to_rect.bottom < clip_rect.bottom))
		put_line_in_gworld(line_gworld,max(to_rect.left,clip_rect.left),to_rect.bottom,
		  min(to_rect.right,clip_rect.right),to_rect.bottom,r,g,b);
	
	if ((to_rect.left >= clip_rect.left) && (to_rect.left < clip_rect.right))
		put_line_in_gworld(line_gworld,to_rect.left,max(to_rect.top,clip_rect.top),
		  to_rect.left,min(to_rect.bottom,clip_rect.bottom),r,g,b);
	if ((to_rect.right >= clip_rect.left) && (to_rect.right < clip_rect.right))
		put_line_in_gworld(line_gworld,to_rect.right,max(to_rect.top,clip_rect.top),
		  to_rect.right,min(to_rect.bottom,clip_rect.bottom),r,g,b);

}

Boolean is_field_type(short i,short j,short field_type)
{
	short k;
	
	for (k = 0; k < NUM_TOWN_PLACED_FIELDS; k++)
		if ((town.preset_fields[k].field_type == field_type) &&
			(town.preset_fields[k].field_loc.x == i) &&
			(town.preset_fields[k].field_loc.y == j))
				return TRUE;
	return FALSE;
}

void make_field_type(short i,short j,short field_type)
{
	short k;
	char str[256];
	
	if (is_field_type(i,j,field_type) == TRUE)
		return;
	for (k = 0; k < NUM_TOWN_PLACED_FIELDS; k++)
		if (town.preset_fields[k].field_type == -1) {
			town.preset_fields[k].field_loc.x = i;
			town.preset_fields[k].field_loc.y = j;
			town.preset_fields[k].field_type = field_type;
			return;
			}
	//sprintf(str,"Field error  %d %d %d",i,j,field_type);
	//give_error(str,"",0);
	//give_error("Each town can have at most 60 fields and special effects (webs, barrels, blood stains, etc.). To place more, use the eraser first.","",0);
}


void take_field_type(short i,short j,short field_type)
{
	short k;
	
	for (k = 0; k < NUM_TOWN_PLACED_FIELDS; k++)
		if ((town.preset_fields[k].field_type == field_type) &&
			(town.preset_fields[k].field_loc.x == i) &&
			(town.preset_fields[k].field_loc.y == j)) {
				town.preset_fields[k].field_type = -1;
				return;
				}
}

Boolean is_web(short i,short j)
{
	return is_field_type(i,j,5);

}
void make_web(short i,short j)
{
	make_field_type(i,j,5);
}
void take_web(short i,short j)
{
	take_field_type(i,j,5);
}

Boolean is_crate(short i,short j)
{
	return is_field_type(i,j,6);
}
void make_crate(short i,short j)
{
	make_field_type(i,j,6);

}
void take_crate(short i,short j)
{
	take_field_type(i,j,6);
}

Boolean is_barrel(short i,short j)
{
	return is_field_type(i,j,7);
}
void make_barrel(short i,short j)
{
	make_field_type(i,j,7);
}
void take_barrel(short i,short j)
{
	take_field_type(i,j,7);
}

Boolean is_fire_barrier(short i,short j)
{
	return is_field_type(i,j,4);
}
void make_fire_barrier(short i,short j)
{
	make_field_type(i,j,4);
}
void take_fire_barrier(short i,short j)
{
	take_field_type(i,j,4);
}

Boolean is_force_barrier(short i,short j)
{
	return is_field_type(i,j,3);
}
void make_force_barrier(short i,short j)
{
	make_field_type(i,j,3);
}
void take_force_barrier(short i,short j)
{
	take_field_type(i,j,3);

}

Boolean is_blocked(short i,short j)
{
	return is_field_type(i,j,1);
}
void make_blocked(short i,short j)
{
	make_field_type(i,j,1);
}
void take_blocked(short i,short j)
{
	take_field_type(i,j,1);

}
Boolean is_sfx(short i,short j,short type)
{
	return is_field_type(i,j,type + 14);
}
void make_sfx(short i,short j,short type)
{
	make_field_type(i,j,type + 14);
}
void take_sfx(short i,short j,short type)
{
	take_field_type(i,j,type + 14);
}

void place_dlog_borders_around_rect(HDIB to_gworld,HWND win,
	RECT border_to_rect)
{
	RECT to_rect;
	
	place_dlog_border_on_win(to_gworld,win,border_to_rect,0,1);
	place_dlog_border_on_win(to_gworld,win,border_to_rect,1,1);
	to_rect = border_to_rect;
	to_rect.top = to_rect.bottom - 14;
	place_dlog_border_on_win(to_gworld,win,to_rect,0,0);
	to_rect = border_to_rect;
	to_rect.left = to_rect.right - 14;
	place_dlog_border_on_win(to_gworld,win,to_rect,1,0);
}
	
// if to_gworld is NULL, put on window
void place_dlog_border_on_win(HDIB to_gworld,HWND win,
	RECT border_to_rect,short horiz_or_vert,short bottom_or_top)
{
	RECT from_rect,to_rect,corner_block = {0,0,14,14},horiz_from = {0,0,607,14}; /**/
	short num_sections,section_width,i;
	HDIB from_gworld;

	if (horiz_or_vert == 0) {
		border_to_rect.bottom = border_to_rect.top + 14;
		from_rect = horiz_from;
		to_rect = border_to_rect;
		to_rect.right -= 14;
		from_rect.right = rect_width(&to_rect);
		from_gworld = (bottom_or_top == 0) ? dlog_horiz_border_bottom_gworld : dlog_horiz_border_top_gworld;
		if (to_gworld != NULL) {
			if ((win == mainPtr) || (win == NULL))
				rect_draw_some_item(from_gworld,from_rect,to_gworld,to_rect,0,0);
				else rect_draw_some_item(from_gworld,from_rect,to_gworld,to_rect,0,2);
			}
			else rect_draw_some_item(from_gworld,from_rect,from_gworld,to_rect,0,(win == mainPtr) ? 1 : 2);
		to_rect = border_to_rect;
		to_rect.left = to_rect.right - 14;
		from_rect = horiz_from;
		from_rect.left = from_rect.right - 14;
		if (to_gworld != NULL) {
			if ((win == mainPtr) || (win == NULL))
				rect_draw_some_item(from_gworld,from_rect,to_gworld,to_rect,0,0);
				else rect_draw_some_item(from_gworld,from_rect,to_gworld,to_rect,0,2);
			}
			else rect_draw_some_item(from_gworld,from_rect,from_gworld,to_rect,0,(win == mainPtr) ? 1 : 2);
		}
	if (horiz_or_vert == 1) {
		section_width = 370;
		border_to_rect.right = border_to_rect.left + 14;
		MacInsetRect(&border_to_rect,0,14);
		num_sections = (rect_height(&border_to_rect) / section_width) + 1;
		for (i = 0; i < num_sections; i++) {
			to_rect = border_to_rect;
			to_rect.top += section_width * i;
			to_rect.bottom = to_rect.top + section_width;
			if (to_rect.bottom > border_to_rect.bottom)
				to_rect.bottom = border_to_rect.bottom;
			from_rect = to_rect;
			OffsetRect(&from_rect,-1 * from_rect.left, -1 * to_rect.top);
			if (to_gworld != NULL) {				
				if ((win == mainPtr) || (win == NULL))
					rect_draw_some_item(dlog_vert_border_gworld,from_rect,to_gworld,to_rect,0,0);
					else rect_draw_some_item(dlog_vert_border_gworld,from_rect,to_gworld,to_rect,0,2);
				}
				else rect_draw_some_item(dlog_vert_border_gworld,from_rect,dlog_vert_border_gworld,to_rect,0,(win == mainPtr) ? 1 : 2);
			}

		}
	//SetPort(cur_port);
}

void cant_draw_graphics_error(graphic_id_type a,char *bonus_string,short bonus_num)
{
	char error[256];
	char error2[256];
	
	if (showed_graphics_error)
		return;
	showed_graphics_error = TRUE;
	sprintf(error,"The editor just failed to load this graphic: sheet %d, icon %d. The editor might have run out of memory but, more likely, the graphic it was trying to find wasn't there.",
		a.which_sheet,a.which_icon);
	if (a.which_sheet < 0)
		sprintf(error,"The editor just failed to load this graphic: sheet %d, icon %d. This means that one of your items or creature types has been left set to its default graphic type.",
			a.which_sheet,a.which_icon);
	
	if (bonus_num >= 0)
		sprintf(error2,"%s %d. You won't see this error again until you load a new outdoor section or town.",bonus_string,bonus_num);
		else sprintf(error2,"You won't see this error again until you load a new outdoor section or town.");
	give_error(error,error2,0);
}
